//Importerer ndvendige pakker:
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import gl4java.awt.GLCanvas;
import gl4java.utils.glut.*; //openGL utility toolkit
import gl4java.utils.textures.*;


public class Flaske extends JFrame implements ActionListener
{
   JPanel contentPane;  
   WindowHandler wHandler; 
   MouseHandler mHandler;
   myGLCanvas canvas_c = null;   
   
   //GUI-variabler
   Button flaskefall=null; 
   Button restart=null;    
   private MenuBar bar;
   private Menu vis, etikettmeny, flat, roter, tekstur;     
   private MenuItem options[];
   private String optionNames[] = {"Flasketuten peker p", "Reis flasken opp"};
   
   //Instanser av de andre klassene i programmet mitt.
   Top top = new Top();
   Upper upper = new Upper();
   Middle middle = new Middle();
   Lower lower = new Lower();
   Bottom bottom = new Bottom();
   Etikett etikett = new Etikett();
   
   //variabler som brukes ved rotering vha. musen     
   float rotx=0.0f;  
   float rotz=0.0f;   
   float lastx=0.0f; 
   float lastz=0.0f; 
   boolean m_is_moving=false; 
   
   //teksturvariabler for etiketten.
   float textPoints2[]=
         {
            0.0f, 0.0f,            
            0.0f, 1.0f,
            1.0f, 0.0f,
            1.0f, 1.0f,
         };
   
   //teksturvariabler for flasken.    
   float textPoints[]=
         {
            0.0f, 0.0f,            
            0.0f, 10.0f,
            10.0f, 0.0f,
            10.0f, 10.0f,
         };
        
   
   /******************************
   *Konstruktr:
   ******************************/     
   public Flaske()
   {
      //Bygger opp framen
      contentPane = (JPanel) this.getContentPane();
      contentPane.setLayout(new BorderLayout());
      this.setSize(new Dimension(500, 500));
      this.setTitle("...Hanne's flaske...");    
      

       //Deler opp framen, med knapp p topp og canvas i midten.
       Dimension d = getSize();
       canvas_c = new myGLCanvas(d.width, d.height);
       contentPane.add("Center", canvas_c);
       
       restart = new Button( "Opp igjen" );
       restart.addActionListener(this);
       contentPane.add("North", restart);
       
       //Setter opp menyen
       bar = new MenuBar();
       vis = new Menu("Alternativer");     
       options = new MenuItem[optionNames.length];
       
       for (int i=0; i < options.length; i++)
       {
         options[i] =  new MenuItem(optionNames[i]);
         vis.add(options[i]);
         options[i].addActionListener(this);
       }           
             
       bar.add(vis);
       setMenuBar(bar);
       

       //legger til mouseListener til frame (for  kunne rotere)
       mHandler = new MouseHandler();
       canvas_c.addMouseListener( mHandler );
       canvas_c.addMouseMotionListener( mHandler );
   
       //legger til windowListener til frame
       wHandler=new WindowHandler();
       this.addWindowListener(wHandler);   
   
       pack();
       show();
   }
   
   /******************************
   *Main-metode:
   ******************************/     
   public static void main(String[] args)
   {
      new Flaske();
   } 
   
   /******************************
   *Hvis bruker klikker p knapp
   ******************************/     
   public void actionPerformed( ActionEvent e ) 
   {      
      //sjekker hva som er trykket p
      String cmd = e.getActionCommand();  
      
      
      //bruker har bedt om flasketuten peker p --> kaller metoden      
      if (cmd.equals("Flasketuten peker p")) 
      {        
         canvas_c.flasketut();      
      }
      
      //bruker har bedt om  reise flasken igjen etter rotering eller flasketuten
      //ved  klikke i menyen
      if (cmd.equals("Reis flasken opp")) 
      {
         rotx=0.0f;
         rotz=0.0f;   
         lastx=0.0f;
         lastz=0.0f;        
         canvas_c.repaint();        
      }
      
      //bruker har bedt om  reise flasken igjen ved  klikke p knapp     
      else if (cmd.equals("Opp igjen")) 
      {
         rotx=0.0f;
         rotz=0.0f;   
         lastx=0.0f;
         lastz=0.0f;          
         canvas_c.display();
      }  
   }
   
   /******************************
   *indre klasse for window events
   ******************************/  
   class WindowHandler implements WindowListener
   {
      public void windowOpened(WindowEvent parm1) {}
      public void windowClosing(WindowEvent parm1)
      {
         System.exit( 0 );
      }
      public void windowClosed(WindowEvent parm1) {}
      public void windowIconified(WindowEvent parm1) {}
      public void windowDeiconified(WindowEvent parm1) {}
      public void windowActivated(WindowEvent parm1) {}
      public void windowDeactivated(WindowEvent parm1) {}
   }


   /******************************
   *indre klasse for mouse events
   ******************************/  
   class MouseHandler implements MouseListener, MouseMotionListener
   {
      public void mouseEntered(MouseEvent e) {}
      public void mouseExited(MouseEvent e) {}
      public void mouseMoved(MouseEvent e) {}
      public void mouseClicked(MouseEvent e){}
      public void mouseReleased(MouseEvent e)
      {
         // objektet beveger seg ikke lenger
         m_is_moving=false;
         canvas_c.repaint();
      }
      public void mousePressed(MouseEvent e)
      { 
         lastx = e.getX();
         lastz = e.getY();
         m_is_moving=true;
      }
      
      /*************************************
      *Roteringskode, lnt av Brres hitbox.
      **************************************/
      public void mouseDragged(MouseEvent e)
      {
         if(!m_is_moving)
            return;
            
         int x = e.getX();
         int y = e.getY();
         
         Dimension dim = e.getComponent().getSize();
         int width = dim.width;
         int height = dim.height;

         rotz += (90.0f*((float)(x-lastx)/(float)(width)));
         rotx += (90.0f*((float)(y-lastz)/(float)(height)));
         

         lastx = x;
         lastz = y;
         

         // repaint with moving flag set
         canvas_c.repaint();
      }
   }

   /******************************
   *indre klasse for openGL-action
   ******************************/     
   private class myGLCanvas extends GLCanvas
   {
      GLUTFunc glut = null;      
      
      public float lookx = 0.0f;
      public float looky = 30.0f;
      public float lookz = 0.0f;    
      
      //Brukes nr flasken faller i flasketuten peker p.
      public float flaske_gradery = 0;
     
      //Brukes nr flasken snurrer rundt i flasketuten peker p.
      public float flaske_rundt = 0;   
              
      int []texName = new int[1];  //array for texturen    
      
      public myGLCanvas(int w, int h)
      {
        super(w, h);
      }     
      
      public void preInit()
      {
         doubleBuffer = true;
         stereoView = false;
         accumSize = 8;
      }
      
      
            
      public void init()
      {
         glut = new GLUTFuncLightImpl(gl, glu);
   
         reshape(getSize().width, getSize().height);
   
         // Gjr klar lyskilden:
         float ambient[] = {0.6f,0.6f,0.6f,1.0f };
         float diffuse[] = {1.0f,1.0f,1.0f,1.0f };
         float position[] = {1.0f,1.0f,1.0f,0.0f };
         float direction[] = {-1.0f,-1.0f,0.0f};
         
         
         gl.glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
         gl.glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);         
         gl.glLightfv(GL_LIGHT0, GL_POSITION, position);       
   
         
         //Enabler lyskilden:
         gl.glEnable(GL_LIGHT0);
         gl.glEnable(GL_LIGHTING);     
         
         
         // gjr tegningen glattere
         gl.glShadeModel(GL_SMOOTH);
         
         // dybdesortering
         gl.glEnable(GL_DEPTH_TEST);
         gl.glDepthFunc(GL_LESS);   
   
         // setter bakgrunnsfarge til hvit:        
         gl.glClearColor((255f/255), (255f/255), (255f/255), 1.0f);
      }

      //******************************
      //Viser frem alt
      //******************************
      public void display()
      {
         if (glj.gljMakeCurrent() == false)
            return;

         showScene(true);  
         
      }

      /******************************
      *showScene
      ******************************/
      void showScene(boolean bRender)
      {
         gl.glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
         gl.glClear(GL_ACCUM_BUFFER_BIT);
         gl.glLoadIdentity();
         
         glu.gluLookAt( lookx,looky,lookz,   // yet, avstand settes
                      0.0f,0.0f,0.0f,        // Ser p
                      0.0f,0.0f,1.0f);       // Velger hvilken som skal vre opp
                      
   
         // roterer
         gl.glTranslatef(0.0f,-20.0f,0.0f);        
         gl.glRotatef(rotx,1.0f,0.0f,0.0f);        
         gl.glRotatef(rotz,0.0f,1.0f,0.0f);       
         gl.glRotatef(rotz,0.0f,0.0f,1.0f);
         
         //Kaller metoden som tegner ut hele flasken med etikett
         makeFlaske();           
         
         //Rydder opp.
         gl.glFlush();        
         glj.gljSwap();
         glj.gljFree();
      }
      
      
      
      /******************************
      *samle-metode for tegnekall til flasken
      ******************************/ 
      public void makeFlaske()
      {  
         gl.glPushMatrix();
         
            //Tegner flasken i den vinkelen flaske_gradery tilsier
            gl.glRotatef(flaske_gradery,0.0f,1.0f,0.0f);
            //Tegner flasken i den vinkelen flaske_rundt tilsier
            gl.glRotatef(flaske_rundt,1.0f,0.0f,0.0f);
           
           
            //Lager etiketten
            //Denne skal ikke vre gjennomsiktig, derfor gjres dette for jeg 
            //enabler blend.
            gl.glEnable(GL_TEXTURE_2D);
            gl.glPushMatrix();
            makeEtikett();
            gl.glPopMatrix();
            gl.glDisable(GL_TEXTURE_2D);        
            
            //"Skrur p" muligheten for  blande farger, slik at det kan vises transparent.
            gl.glEnable(GL_BLEND);
            gl.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); 
            
            //Kaller metoden som setter riktig lyssetting for  f flasken gjennomsiktig
            //og med riktig skinn i.
            setMaterialBottle();     
            
            
            //Lager toppen av flasken
            gl.glEnable(GL_TEXTURE_2D);
            gl.glPushMatrix();
            makeTop();
            gl.glPopMatrix();
            gl.glDisable(GL_TEXTURE_2D);
            
            
            //Lager flaskehals av flasken
            gl.glEnable(GL_TEXTURE_2D);
            gl.glPushMatrix();
            makeUpper();
            gl.glPopMatrix();
            gl.glDisable(GL_TEXTURE_2D);
            
             
            //Lager kroppen p flasken
            gl.glEnable(GL_TEXTURE_2D);
            gl.glPushMatrix();
            makeMiddle();
            gl.glPopMatrix();
            gl.glDisable(GL_TEXTURE_2D);
            
            
            //Lager lager nederste del av flasken
            gl.glEnable(GL_TEXTURE_2D);
            gl.glPushMatrix();
            makeLower();
            gl.glPopMatrix();
            gl.glDisable(GL_TEXTURE_2D);
            
            //Lager bunnen av flasken
            gl.glEnable(GL_TEXTURE_2D);
            gl.glPushMatrix();
            makeBottom();
            gl.glPopMatrix();
            gl.glDisable(GL_TEXTURE_2D);
            
            //"Skrur av" blend igjen.
            gl.glDisable(GL_BLEND);
            
         gl.glPopMatrix();
      }
      
      
      /******************************************
      *metode som tar seg av flasketuten peker p
      *******************************************/
      public void flasketut()
      {                    
         //denne forlkken styrer fallet til flasken:       
         for (int k=0;k<91;k++)
         {
            flaske_gradery = k;
            k = k + 10;          
            display();
         }  
         
         
         //denne forlkken styrer hvor fort flasken gr rundt.
         float j = 80.0f;                 
         for (float i=0;i<1080;i++)
         {
            flaske_rundt = i;
            
            if(i<360)
                j = 65.0f;
            else if(i>360 && i<540)
               j = 40.0f;
            else if(i>540 && i<720)
               j = 25.0f;
            else if(i>720 && i<900)
               j = 10.0f;  
            else if(i>900 && i<1000)
               j = 5.0f;
            else if(i>1000 && i<1070)
               j = 1.0f;       
            else
               j = 0.01f;
               
            i = i + j;
            display();
         } 
         
        //nullstiller
        flaske_gradery = 0f;
      }
      
     
      /***************************************************
      *Metode som blir kallt ved endring av str. p canvas
      ****************************************************/
       public void reshape(int w, int h)
      {
         gl.glViewport(0, 0, w, h);
         gl.glMatrixMode(GL_PROJECTION);
         gl.glLoadIdentity();
         glu.gluPerspective( 45.0, (float) w/h, 1.0, 500.0 );
         gl.glMatrixMode(GL_MODELVIEW);
      }
      
      /**********************************
      *Gjennomsiktig materiale p flasken
      ***********************************/
      public void setMaterialBottle()
      {
         float amb[] = {0.1f, 0.73f, 1.0f, 0.5f};
         float diff[] = {0.95f, 0.62f, 0.95f, 0.5f};
         float spec[] = {1.0f, 1.0f, 1.0f, 0.5f};
         
         float shine = 50f;
            
         gl.glMaterialfv(GL_FRONT, GL_AMBIENT, amb);
         gl.glMaterialfv(GL_FRONT, GL_DIFFUSE, diff);
         gl.glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
         gl.glMaterialf(GL_FRONT, GL_SHININESS, shine);
         
         gl.glEnable(GL_LIGHT0);
         gl.glEnable(GL_LIGHTING);
      }
      
   
      /**********************************
      *Metode som lager toppen av flasken
      ***********************************/
      public void makeTop()
      {
         //spesifiserer fil med tekstur
         String filnavn="vann.png";
         
         //kaller teksturmetoden, for  loade bildet
         textures(filnavn);
         
         //autoberegning av normaler
         gl.glEnable(GL_AUTO_NORMAL);
         gl.glEnable(GL_NORMALIZE);  
         
         //Hvordan teksturen skal legges p
         gl.glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
         gl.glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
         gl.glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
         gl.glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
         
         //modulate her for at lyset skal f noen effekt nr det er tekstur   
         gl.glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);         
         
         
         //gjr bezierflaten klar  
         gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,top.getUN(),
            0.0f,1.0f,top.getUN()*3,top.getVN(),top.getM());
         
         //gjr klar for  legge ut tekstur
         gl.glMap2f(GL_MAP2_TEXTURE_COORD_2,
              0,1,2,2,
              0,1,4,2,textPoints);  
                  
         gl.glEnable(GL_MAP2_TEXTURE_COORD_2);   
         gl.glEnable(GL_MAP2_VERTEX_3);
         
         //Tegner ut bezierflatene 
         gl.glMapGrid2f(20, 0.0f, 1.0f, 10, 0.0f, 1.0f);       
         gl.glRotatef(90.0f,1.0f,0.0f,0.0f);       
         gl.glEvalMesh2(GL_FILL, 0, 20, 0, 10); 
         //roterer rundt y og tegner p nytt for  f en hel flaske(rund)
         gl.glRotatef(180.0f,0.0f,1.0f,0.0f);         
         gl.glEvalMesh2(GL_FILL,0,20,0,10);
         
      }
      
      /******************************
      *Metode som lager flaskehalsen
      ******************************/
      public void makeUpper(){   
         
         //autoberegning av normaler 
         gl.glEnable(GL_AUTO_NORMAL);
         gl.glEnable(GL_NORMALIZE);
         
         //modulate her for at lyset skal f noen effekt nr det er tekstur         
         gl.glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
         
         //gjr bezierflaten klar               
         gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,upper.getUN(),
            0.0f,1.0f,upper.getUN()*3,upper.getVN(),upper.getM());
         
         //gjr teksturen klar
         gl.glMap2f(GL_MAP2_TEXTURE_COORD_2,
              0,1,2,2,
              0,1,4,2,textPoints);  
       
         
         gl.glEnable(GL_MAP2_TEXTURE_COORD_2);                 
         gl.glEnable(GL_MAP2_VERTEX_3);
         
         //Tegner ut       
         gl.glMapGrid2f(20, 0.0f, 1.0f, 10, 0.0f, 1.0f);       
         gl.glRotatef(90.0f,1.0f,0.0f,0.0f);       
         gl.glEvalMesh2(GL_FILL, 0, 20, 0, 10);
         
         //roterer rundt y og tegner p nytt for  f en hel flaske(rund)
         gl.glRotatef(180.0f,0.0f,1.0f,0.0f);         
         gl.glEvalMesh2(GL_FILL,0,20,0,10);

         
      }
      
      /******************************
      *Metode som lager kroppen p flasken
      ******************************/
      public void makeMiddle()
      {
         //autoberegning av normaler 
         gl.glEnable(GL_AUTO_NORMAL);
         gl.glEnable(GL_NORMALIZE); 
         

         //modulate her for at lyset skal f noen effekt nr det er tekstur       
         gl.glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
         
         //gjr bezierflaten klar              
         gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,middle.getUN(),
            0.0f,1.0f,middle.getUN()*3,middle.getVN(),middle.getM());
         
         //gjr teksturen klar
         gl.glMap2f(GL_MAP2_TEXTURE_COORD_2,
              0,1,2,2,
              0,1,4,2,textPoints);  
       
         gl.glEnable(GL_MAP2_TEXTURE_COORD_2);                 
         gl.glEnable(GL_MAP2_VERTEX_3);
            
         //Tegner ut
         gl.glMapGrid2f(20, 0.0f, 1.0f, 10, 0.0f, 1.0f);    
         gl.glRotatef(90.0f,1.0f,0.0f,0.0f);       
         gl.glEvalMesh2(GL_FILL, 0, 20, 0, 10);
         
        //roterer rundt y og tegner p nytt for  f en hel flaske(rund)
         gl.glRotatef(180.0f,0.0f,1.0f,0.0f);         
         gl.glEvalMesh2(GL_FILL,0,20,0,10);
         
      }

      
      /******************************
      *Metode som lager nederste del av flasken
      ******************************/
      public void makeLower(){
         
         //autoberegning av normaler
         gl.glEnable(GL_AUTO_NORMAL);
         gl.glEnable(GL_NORMALIZE);    
         
         //modulate her for at lyset skal f noen effekt nr det er tekstur   
         gl.glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
         
         //gjr bezierflaten klar            
         gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,lower.getUN(),
            0.0f,1.0f,lower.getUN()*3,lower.getVN(),lower.getM());
         
         //gjr teksturen klar
         gl.glMap2f(GL_MAP2_TEXTURE_COORD_2,
              0,1,2,2,
              0,1,4,2,textPoints);  
       
         gl.glEnable(GL_MAP2_TEXTURE_COORD_2);                 
         gl.glEnable(GL_MAP2_VERTEX_3);
         
         //Tegner ut
         gl.glMapGrid2f(20, 0.0f, 1.0f, 10, 0.0f, 1.0f);       
         gl.glRotatef(90.0f,1.0f,0.0f,0.0f);       
         gl.glEvalMesh2(GL_FILL, 0, 20, 0, 10); 
         
         //roterer rundt y og tegner p nytt for  f en hel flaske(rund)
         gl.glRotatef(180.0f,0.0f,1.0f,0.0f);         
         gl.glEvalMesh2(GL_FILL,0,20,0,10);
         
      }
      
      /***********************************
      *Metode som lager bunnen av flasken
      ************************************/
      public void makeBottom(){
         
         //autoberegning av normaler
         gl.glEnable(GL_AUTO_NORMAL);
         gl.glEnable(GL_NORMALIZE); 
          
         //modulate her for at lyset skal f noen effekt nr det er tekstur     
         gl.glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
         
         //gjr bezierflaten klar               
         gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,bottom.getUN(),
            0.0f,1.0f,bottom.getUN()*3,bottom.getVN(),bottom.getM());
         
         //gjr klar teksturen
         gl.glMap2f(GL_MAP2_TEXTURE_COORD_2,
              0,1,2,2,
              0,1,4,2,textPoints);  
       
         gl.glEnable(GL_MAP2_TEXTURE_COORD_2);                 
         gl.glEnable(GL_MAP2_VERTEX_3);
         
         //Tegner ut
         gl.glMapGrid2f(20, 0.0f, 1.0f, 10, 0.0f, 1.0f);            
         gl.glEvalMesh2(GL_FILL, 0, 20, 0, 10); 
                  
      }
      
      
      
      /******************************
      *Metode som lager etiketten
      ******************************/
      public void makeEtikett()     
      {
            //spesifiserer fil med tekstur
            textures(etikett.getFilnavn());
            
            //autoberegning av normaler
            gl.glEnable(GL_AUTO_NORMAL);
            gl.glEnable(GL_NORMALIZE);  
            
            //Hvordan teksturen skal legges p
            gl.glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
            gl.glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
            gl.glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
            gl.glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);                    
            gl.glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
                     
            //gjr klar bezierflaten      
            gl.glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,etikett.getUN(),
               0.0f,1.0f,etikett.getUN()*3,etikett.getVN(),etikett.getM());
            
            //gjr klar teksturen
            gl.glMap2f(GL_MAP2_TEXTURE_COORD_2,
                 0,1,2,2,
                 0,1,4,2,textPoints2); 
                           
            gl.glEnable(GL_MAP2_TEXTURE_COORD_2);
            gl.glEnable(GL_MAP2_VERTEX_3);                  
            
            //tegner ut
            gl.glMapGrid2f(20, 0.0f, 1.0f, 10, 0.0f, 1.0f);       
            gl.glRotatef(90.0f, 1.0f, 0.0f, 0.0f);
            gl.glRotatef(45.0f, 0.0f, 0.0f, 1.0f);          
            gl.glEvalMesh2(GL_FILL, 0, 20, 0, 10); 
            
      }   
               
      
      /************************************************
      *Metode som tar seg av texturer:
      *
      *Forfatter: Eirin . Blstrud
      *************************************************/
      public void textures(String filnavn) {
       
        //Laster inn bildet       
        PngTextureLoader txtLoader = new PngTextureLoader(gl, glu);
        txtLoader.readTexture(filnavn);

        //Hvis det gr greit  laste inn bildet s..
        if(txtLoader.isOk()) {
            
            //Genererer en tekstur
            gl.glGenTextures(1,texName);  
            gl.glBindTexture(GL_TEXTURE_2D,texName[0]);
            
            //Lager teksturen og gir informasjon om bildet.
            gl.glTexImage2D(GL_TEXTURE_2D,
               0,
               3,
               txtLoader.getImageWidth(),
               txtLoader.getImageHeight(),
               0,
               GL_RGB,
               GL_UNSIGNED_BYTE,
               txtLoader.getTexture());
         }   
      } 
   }
         
}
